--TODO
--Ajouter les nouvelles transmutations et les nouveaux cd de couture
--Vérifier les cd déjà existant et leur durée
--Etoffe CD non commun, Tranmust commun
--Ajouter un menu dans interface=>addons ajouter les options existantes et une option pour wype les datas
--/////SET VAR
local titleColor = "|cff00ffff"
local cyan = "|cff00ffff"
local white = "|cffffffff"
local grey = "|cff888888"
local green = "|cff00ff00"
local red = "|cffff0000"
local fontSize = 17
local stringsToDisplay = {}

local title = "Work Cooldown Tracker"

local labelsFrames = {}
local AllEventHandlers = {}
local spellsIDList = {}
spellsIDList[28581] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Eau en Ombre
spellsIDList[28583] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Feu en Mana
spellsIDList[28582] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Mana en Feu
spellsIDList[28580] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Ombre en Eau
spellsIDList[28585] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Terre en Vie
spellsIDList[28584] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Vie en Terre
spellsIDList[32766] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation : Diamant brûleciel
spellsIDList[32765] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation : Diamant tonneterre
spellsIDList[28566] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Air en Feu
spellsIDList[28569] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Eau en Air
spellsIDList[28568] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Feu en Terre
spellsIDList[29688] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Pouvoir
spellsIDList[28567] = {duration = 72000, commune = true, label = "Transmutation"} -- Transmutation primordiale : Terre en Eau
spellsIDList[31373] = {duration = 331200, commune = false} -- Etoffe ensorcelée
spellsIDList[26751] = {duration = 331200, commune = false} -- Etoffe lunaire primordiale
spellsIDList[36686] = {duration = 331200, commune = false} -- Etoffe d'ombre
--spellsIDList[10140] = {duration = 30, commune = true, label = "Transmutation"} -- Invocation d'eau rang 7 (POUR TEST)
--spellsIDList[28612] = {duration = 30, commune = true, label = "Transmutation"} -- Invocation de nourriture rang 7 (POUR TEST)

local playerName = UnitName("player");
toggle = toggle or true
mainToggle = mainToggle or true
--/////SET VAR FIN

--/////CREATE MAIN FRAME
local firstFrame = CreateFrame("Frame", "frame", UIParent)
frame:SetMovable(true)
frame:EnableMouse(true)
frame:RegisterForDrag("LeftButton")
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
frame:SetScript("OnMouseDown", function(self, button)
	if button == "RightButton" then 
		if toggle == true then
			toggle = false; --print(titleColor .. title .. white .. " - Main frame content hide");			
		else
			toggle = true; --print(titleColor .. title .. white .. " - Main frame content show")
		end
	end
end)
frame:SetPoint("CENTER"); frame:SetWidth(300); frame:SetHeight(50);

firstFrame.text = firstFrame:CreateFontString(nil,"ARTWORK") 
firstFrame.text:SetFont("Fonts\\ARIALN.ttf", fontSize, "OUTLINE")
firstFrame.text:SetPoint("TOPLEFT",0,0)

local tex = frame:CreateTexture("ARTWORK");
tex:SetAllPoints();
tex:SetTexture(1, 1, 1); tex:SetAlpha(1);
tex:SetColorTexture(0, 0, 0, 0);
--/////CREATE MAIN FRAME FIN

--/////FUNCTIONS UTILS
local function in_array(val, tab)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

local function array_key_exists(val, tab)
    for index, value in pairs(tab) do
        if index == val then
            return true
        end
    end

    return false
end
--/////FUNCTIONS UTILS

--/////FUNCTION INFO
local function info()
	print(cyan..title)
	print(cyan.."Right click on the title frame to Show/Hide the main frame content.")
	print(cyan..SLASH_WCT1.." help - For further information")
end
--/////FUNCTION INFO FIN

--/////FUNCTION TO HIDE OR SHOW IN FUNCTION OF TOGGLE VAR
local function hideOrShow()
	if savedFontSize ~= nil then fontSize = savedFontSize end
	if savedTitleColor ~= nil then titleColor = savedTitleColor end
	
	firstFrame.text:SetFont("Fonts\\ARIALN.ttf", fontSize, "OUTLINE")
	
	if toggle == true then 
		firstFrame.text:SetText(titleColor..title)
	else
		firstFrame.text:SetText(titleColor..title..grey.." (hidden)")
	end
	
	for k, v in ipairs(labelsFrames) do
		if toggle == true then
			v:Show()
		else
			v:Hide()
		end
	end
	
	if mainToggle == false then 
		firstFrame.text:SetText("")
		toggle = false
	end
end
--/////FUNCTION TO HIDE OR SHOW IN FUNCTION OF TOGGLE VAR FIN

--/////FUNCTION TO CREATE/EDIT AND DISPLAY SUB FRAME IN MAIN FRAME
local function display(stringsToDisplay)
	local length = table.getn(stringsToDisplay)
	
	for i=1, length do
		if labelsFrames[i] == nil then
			labelsFrames[i] = CreateFrame("Frame",nil,firstFrame)
			labelsFrames[i]:SetWidth(1) 
			labelsFrames[i]:SetHeight(1) 
			labelsFrames[i]:SetAlpha(.90);
			labelsFrames[i]:SetPoint("LEFT",0,0)
			labelsFrames[i].text = labelsFrames[i]:CreateFontString(nil,"ARTWORK") 
			labelsFrames[i].text:SetFont("Fonts\\ARIALN.ttf", fontSize-2, "OUTLINE")
			if i == 1 then 
				labelsFrames[i].text:SetPoint("LEFT",0,-5)
			elseif i > 1 then
				labelsFrames[i].text:SetPoint("LEFT",0,((i-1)*-fontSize-2-5))
			end
			labelsFrames[i].text:SetText(stringsToDisplay[i])
		elseif labelsFrames[i] ~= nil then
			labelsFrames[i].text:SetFont("Fonts\\ARIALN.ttf", fontSize-2, "OUTLINE")
			labelsFrames[i].text:SetText(stringsToDisplay[i])
		end
    end
	
	hideOrShow()
end
--/////FUNCTION TO CREATE/EDIT AND DISPLAY SUB FRAME IN MAIN FRAME FIN

--/////FUNCTION TO CREATE CONTENT FRAME WITH DATA
local function refresh_cooldown()
	local timestamp = time()
	stringsToDisplay = wipe(stringsToDisplay)
	forceShow = forceShow or true
	forceHide = forceHide or false
	local available = false;

	for k, v in pairs(tabCooldownC) do
		for kk, vv in pairs(tabCooldownC[k]) do
			local finalString
			local timeLeft = tabCooldownC[k][kk]["startTime"] + tabCooldownC[k][kk]["duration"] - timestamp

			if timeLeft > 0 then
				tabCooldownC[k][kk]["value"] = string.format(SecondsToTime(timeLeft))
			else
				available = true
				tabCooldownC[k][kk]["value"] = nil
				if forceShow == true then
					mainToggle = true; toggle = true;
				end
			end

			if k ~= playerName then 
				if tabCooldownC[k][kk]["value"] ~= nil then
					finalString = k .. " - " .. tabCooldownC[k][kk]["name"] .. " : " .. red .. tabCooldownC[k][kk]["value"]  			
				else
					finalString = k .. " - " .. tabCooldownC[k][kk]["name"] .. " : " .. green .. "Available"  			
				end
			elseif k == playerName then
				if tabCooldownC[k][kk]["value"] ~= nil then
					finalString = k .. " - " .. tabCooldownC[k][kk]["name"] .. " : " .. red .. tabCooldownC[k][kk]["value"]  			
				else
					finalString = k .. " - " .. tabCooldownC[k][kk]["name"] .. " : " .. green .. "Available"  			
				end
			end
			table.insert(stringsToDisplay,finalString)
		end
	end
	
	if available == false and forceHide == true then
		mainToggle = false;
	end
	display(stringsToDisplay)
end
--/////FUNCTION TO CREATE CONTENT FRAME WITH DATA FIN

--/////FUNCTION TO SET DATA COOLDOWN
local function set_cooldown(target, castGUID, spellID)
	if target == "player" and array_key_exists(spellID, spellsIDList) then 
		local timestamp = time()
		local startTime, duration, enable, modRate = GetSpellCooldown(spellID)
		local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spellID)

		if spellsIDList[spellID]["commune"] == true then
			tabCooldownC[playerName][spellsIDList[spellID]["label"]] = {startTime = timestamp, duration = spellsIDList[spellID]["duration"], name = spellsIDList[spellID]["label"], spellID = spellID}
		else
			tabCooldownC[playerName][spellID] = {startTime = timestamp, duration = spellsIDList[spellID]["duration"], name = name, spellID = spellID}
		end		
	end
	
	refresh_cooldown()
end
--/////FUNCTION TO SET DATA COOLDOWN FIN

--/////SLASH COMMAND
SLASH_WCT1 = "/wct" 
SLASH_WCTCHANGETITLECOLOR1 = "/wcttitlecolor"
SLASH_WCTCHANGEFONTSIZE1 = "/wctfontsize"

SlashCmdList["WCT"] = function(arg1)
	if arg1 == "" then
		info()
	elseif arg1 == "help" then
		print(titleColor..title)
		print(cyan..SLASH_WCT1.." hide - Hide the main frame.")
		print(cyan..SLASH_WCT1.." show - Show the main frame.")
		print(cyan..SLASH_WCTCHANGETITLECOLOR1.." color - Change title color used (white, grey, cyan, green, red).")
		print(cyan..SLASH_WCTCHANGEFONTSIZE1.." size - Change the font size used (10-22). Actually "..fontSize..".")
		local forceShowEtat; if forceShow == true then forceShowEtat = "on" else forceShowEtat = "off" end
		print(cyan..SLASH_WCT1.. " forceShowOn|forceShowOff - If forceShow is on, the main frame will be displayed if you have hidden it when a cooldown is available. Actually "..forceShowEtat..".")
		local forceHideEtat; if forceHide == true then forceHideEtat = "on" else forceHideEtat = "off" end
		print(cyan..SLASH_WCT1.. " forceHideOn|forceHideOff - If forceHide is on, the main frame will be hidden if you have not cooldown available. Actually "..forceHideEtat..".")
		print(cyan.."(If you try to /wct show with forceHideOn and no available cooldown, the frame will not be displayed.)")
		print(cyan..SLASH_WCT1.. " wipeData - Delete all data on all characters")
	elseif arg1 == "hide" then
		mainToggle = false;
		print(titleColor..title.." - Main frame hidden")
	elseif arg1 == "show" then
		mainToggle = true;
		toggle = true;
		print(titleColor..title.." - Main frame showed")
		print(cyan.."(If you try to /wct show with forceHideOn and no available cooldown, the frame will not be displayed. '/wct help' for further info)")
	elseif arg1 == "forceShowOn" then
		forceShow = true
		print(titleColor..title.." - forceShow is on")
	elseif arg1 == "forceShowOff" then
		forceShow = false
		print(titleColor..title.." - forceShow is off")
	elseif arg1 == "forceHideOn" then
		forceHide = true
		print(titleColor..title.." - forceHide is on")
	elseif arg1 == "forceHideOff" then
		forceHide = false
		print(titleColor..title.." - forceHide is off")
	elseif arg1 == "wipeData" then
		tabCooldownC = {}
		tabCooldownC[playerName] = {}
		forceShow = true
		forceHide = false
		for k, v in ipairs(labelsFrames) do
			v.text:SetText("")
		end
		print(titleColor..title.." - wipe data")
		info()
	else
		print(titleColor..title.." - Invalid argument : "..arg1)
	end
end

SlashCmdList["WCTCHANGETITLECOLOR"] = function(color)
	if color == "grey" then savedTitleColor = grey end
	if color == "cyan" then savedTitleColor = cyan end
	if color == "green" then savedTitleColor = green end
	if color == "red" then savedTitleColor = red end
	if color == "white" then savedTitleColor = white end
	
	titleColor = savedTitleColor
end

SlashCmdList["WCTCHANGEFONTSIZE"] = function(size)
	size = tonumber(size)
	
	if size > 9 and size < 23 then
		savedFontSize = size
		fontSize = savedFontSize
	end
end
--/////SLASH COMMAND FIN

--/////EVENT ON CAST SUCCEEDED
function AllEventHandlers:UNIT_SPELLCAST_SUCCEEDED(...)
	set_cooldown(...)
end

--/////EVENT ON EACH LOADING
function AllEventHandlers:PLAYER_ENTERING_WORLD (...)
	local defaults = {}
	--Pour chaque version si la structure de tabCooldown change il faudra changer le nom de la variable dans le .toc et dans le code
	tabCooldownC = tabCooldownC or defaults

	if tabCooldownC[playerName] == nil then
		tabCooldownC[playerName] = {}
	end

	info()
end

--/////OnUpdate EVENT WHO PROC ON EACH FRAME IG
firstFrame : SetScript ("OnUpdate", function ( self , event , ...)
	refresh_cooldown()
end)

--/////REGISTER EVENTS
firstFrame : SetScript ("OnEvent", function ( self , event , ...)
	AllEventHandlers[event](self, ...)
end)

for event, _ in pairs (AllEventHandlers) do
	firstFrame:RegisterEvent(event)
end
